﻿Type=Class
Version=7.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'xCustomListView v1.01
#Event: ItemClick (Index As Int, Value As Object)
#Event: ReachEnd
#DesignerProperty: Key: HorizontalIfTrue, DisplayName: Horizontal If True, FieldType: Boolean, DefaultValue: False, Description: Horizontal if True
#DesignerProperty: Key: DividerColor, DisplayName: Divider Color, FieldType: Color, DefaultValue: 0xFFD9D7DE
#DesignerProperty: Key: DividerHeight, DisplayName: Divider Height, FieldType: Int, DefaultValue: 2
#DesignerProperty: Key: PressedColor, DisplayName: Pressed Color, FieldType: Color, DefaultValue: 0xFF7EB4FA
#DesignerProperty: Key: InsertAnimationDuration, DisplayName: Insert Animation Duration, FieldType: Int, DefaultValue: 300
Sub Class_Globals
	Private mBase As B4XView
	Public sv As B4XView
	Type CLVItem(Panel As B4XView, Height As Int, Value As Object, Color As Int, TextItem As Boolean)
	Private items As List
	Private dividerHeight As Float
	Private EventName As String
	Private CallBack As Object
	Public DefaultTextColor As Int
	Public DefaultTextBackgroundColor As Int
	Public AnimationDuration As Int = 300
	Private LastReachEndEvent As Long
	Private PressedColor As Int
	Private xui As XUI
	Private LastAnimatedAction As Int
	Private DesignerLabel As Label
	Private bHorizontal As Boolean
#if B4J
	Private fx As JFX
#else if B4A
	Private su As StringUtils
#else if B4i

#end if

End Sub

Public Sub Initialize (vCallBack As Object, vEventName As String)
	bHorizontal = False
	EventName = vEventName
	CallBack = vCallBack
	sv = CreateScrollView
	items.Initialize
	DefaultTextBackgroundColor = xui.Color_White
	DefaultTextColor = xui.Color_Black
End Sub

Public Sub Initialize2 (vCallBack As Object, vEventName As String, bHoriz As Boolean)
	bHorizontal = bHoriz
	EventName = vEventName
	CallBack = vCallBack
	sv = CreateScrollView
	items.Initialize
	DefaultTextBackgroundColor = xui.Color_White
	DefaultTextColor = xui.Color_Black
End Sub

Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	Dim o As Object = Props.Get("HorizontalIfTrue")
	If Not(o=Null) Then
		Dim b As Boolean
		b = o
		If b Then
		bHorizontal = True
		sv = CreateScrollView
		End If
	End If
	mBase = Base
	mBase.AddView(sv, 0, 0, mBase.Width, mBase.Height)
	sv.ScrollViewInnerPanel.Color = xui.PaintOrColorToColor(Props.Get("DividerColor"))
	dividerHeight = DipToCurrent(Props.Get("DividerHeight")) 'need to scale the value
	PressedColor = xui.PaintOrColorToColor(Props.Get("PressedColor"))
	AnimationDuration = Props.GetDefault("InsertAnimationDuration", AnimationDuration)
	DefaultTextColor = xui.PaintOrColorToColor(Lbl.TextColor)
	DefaultTextBackgroundColor = mBase.Color
	DesignerLabel = Lbl
	Base_Resize(mBase.Width, mBase.Height)
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	sv.SetLayoutAnimated(0, 0, 0, Width, Height)
	If bHorizontal Then
		sv.ScrollViewContentHeight = Height
#if B4J
		sv.ScrollViewContentHeight = Height - 20 'horizontal scrollbar
#End If
		For Each it As CLVItem In items
			it.Panel.Height = sv.ScrollViewContentHeight
			it.Panel.GetView(0).Height = it.Panel.Height
			If it.TextItem Then
				Dim lbl As B4XView = it.Panel.GetView(0).GetView(0)
				lbl.SetLayoutAnimated(0, lbl.Left, lbl.Top, lbl.Width, it.Panel.Height - lbl.Top)
			End If
		Next
	Else
		sv.ScrollViewContentWidth = Width
#if B4J
		sv.ScrollViewContentWidth = Width - 20 'vertical scrollbar
#End If
		For Each it As CLVItem In items
			it.Panel.Width = sv.ScrollViewContentWidth
			it.Panel.GetView(0).Width = it.Panel.Width
			If it.TextItem Then
				Dim lbl As B4XView = it.Panel.GetView(0).GetView(0)
				lbl.SetLayoutAnimated(0, lbl.Left, lbl.Top, it.Panel.Width - lbl.Left, lbl.Height)
			End If
		Next
	End If
End Sub

Public Sub AsView As B4XView
	Return sv
End Sub

'Clears all items.
Public Sub Clear
	items.Clear
	sv.ScrollViewInnerPanel.RemoveAllViews
	If bHorizontal Then
		sv.ScrollViewContentWidth = 0
	Else
		sv.ScrollViewContentHeight = 0
	End If
End Sub

Public Sub GetBase As B4XView
	Return mBase
End Sub

'Returns the number of items.
Public Sub getSize As Int
	Return items.Size
End Sub

Private Sub GetItem(Index As Int) As CLVItem
	Return items.Get(Index)
End Sub

'Returns the Panel stored at the specified index.
Public Sub GetPanel(Index As Int) As B4XView
	Return GetItem(Index).Panel.GetView(0)
End Sub

'Returns the value stored at the specified index.
Public Sub GetValue(Index As Int) As Object
	Return GetItem(Index).Value
End Sub

'Removes the item at the specified index.
Public Sub RemoveAt(Index As Int)
	If getSize <= 1 Then
		Clear
		Return
	End If
	Dim RemoveItem As CLVItem = items.Get(Index)
	Dim p As B4XView
	For i = Index + 1 To items.Size - 1
		Dim item As CLVItem = items.Get(i)
		p = item.Panel
		p.Tag = i - 1
		If bHorizontal Then
			Dim NewTop As Int = p.Left - item.Height - dividerHeight ' not really height, reused for width
			p.Left = NewTop
		Else
			Dim NewTop As Int = p.Top - item.Height - dividerHeight
			p.top = NewTop
		End If
	Next
	If bHorizontal Then
		sv.ScrollViewContentWidth = sv.ScrollViewContentWidth - RemoveItem.Height - dividerHeight ' not really height, reused for width
	Else
		sv.ScrollViewContentHeight = sv.ScrollViewContentHeight - RemoveItem.Height - dividerHeight
	End If
	items.RemoveAt(Index)
	RemoveItem.Panel.RemoveViewFromParent
End Sub


'Adds a text item. The item height will be adjusted based on the text.
Public Sub AddTextItem(Text As Object, Value As Object)
	InsertAtTextItem(items.Size, Text, Value)
End Sub

'Inserts a text item at the specified index.
Public Sub InsertAtTextItem(Index As Int, Text As Object, Value As Object)
	Dim pnl As B4XView = CreatePanel("")
	Dim lbl As B4XView = CreateLabel(Text)
	lbl.Height = Max(50dip, lbl.Height)
	If bHorizontal Then
		pnl.AddView(lbl, 2dip, 5dip, lbl.Width, sv.ScrollViewContentHeight - 10dip)
	Else
		pnl.AddView(lbl, 5dip, 2dip, sv.ScrollViewContentWidth - 10dip, lbl.Height)
	End If
	lbl.TextColor = DefaultTextColor
	pnl.Color = DefaultTextBackgroundColor
	If bHorizontal Then
		pnl.Width = lbl.Width + 2dip
	Else
		pnl.Height = lbl.Height + 2dip
	End If
	InsertAt(Index, pnl, Value)
	Dim item As CLVItem = GetItem(Index)
	item.TextItem = True
End Sub

'Adds a custom item at the specified index.
Public Sub InsertAt(Index As Int, pnl As B4XView, Value As Object)
	InsertAtImpl(Index, pnl, pnl.Height, pnl.Width, Value, 0)
End Sub

	
Private Sub InsertAtImpl(Index As Int, Pnl As B4XView, ItemHeight As Int, ItemWidth As Int, Value As Object, InitialHeight As Int)
	'create another panel to handle the click event
	Dim p As B4XView = CreatePanel("Panel")
	p.Color = Pnl.Color
	Pnl.Color = xui.Color_Transparent
	If bHorizontal Then
		p.AddView(Pnl, 0, 0, ItemWidth, sv.ScrollViewContentHeight)
	Else
		p.AddView(Pnl, 0, 0, sv.ScrollViewContentWidth, ItemHeight)
	End If
	p.Tag = Index
	Dim IncludeDividierHeight As Int
	If InitialHeight = 0 Then IncludeDividierHeight = dividerHeight Else IncludeDividierHeight = 0
	Dim NewItem As CLVItem
	NewItem.Panel = p
	If bHorizontal Then
		NewItem.Height = ItemWidth ' reused as width for horiz
	Else
		NewItem.Height = ItemHeight
	End If
	NewItem.Value = Value
	NewItem.Color = p.Color
	If Index = items.Size And InitialHeight = 0 Then
		items.Add(NewItem)
		Dim top As Int ' reused as left for horiz
		If bHorizontal Then
			If Index = 0 Then top = dividerHeight Else top = sv.ScrollViewInnerPanel.Width
			sv.ScrollViewInnerPanel.AddView(p, top, 0, ItemWidth, sv.Height)
		Else
			If Index = 0 Then top = dividerHeight Else top = sv.ScrollViewInnerPanel.Height
			sv.ScrollViewInnerPanel.AddView(p, 0, top, sv.Width, ItemHeight)
		End If
	Else
		CleanAfterAnimation
		Dim top As Int
		If Index = 0 Then
			top = dividerHeight
		Else
			Dim PrevItem As CLVItem = items.Get(Index - 1)
			If bHorizontal Then
				top = PrevItem.Panel.left + PrevItem.Height + dividerHeight ' reusing for width
			Else
				top = PrevItem.Panel.top + PrevItem.Height + dividerHeight
			End If
		End If
		For i = Index To items.Size - 1
			Dim it As CLVItem = items.Get(i)
			If bHorizontal Then
				Dim NewTop As Int = it.Panel.left + ItemWidth - InitialHeight + IncludeDividierHeight
				If  Min(NewTop, it.Panel.Left) - sv.ScrollViewOffsetX < sv.Width Then
					it.Panel.SetLayoutAnimated(AnimationDuration, NewTop, 0, it.Height, it.Panel.Height)
				Else
					it.Panel.left = NewTop
				End If
			Else
				Dim NewTop As Int = it.Panel.top + ItemHeight - InitialHeight + IncludeDividierHeight
				If  Min(NewTop, it.Panel.Top) - sv.ScrollViewOffsetY < sv.Height Then
					it.Panel.SetLayoutAnimated(AnimationDuration, 0, NewTop, it.Panel.Width, it.Height)
				Else
					it.Panel.top = NewTop
				End If
			End If
			it.Panel.Tag = i + 1
		Next
		items.InsertAt(Index, NewItem)
		If bHorizontal Then
			sv.ScrollViewInnerPanel.AddView(p, top, 0, InitialHeight, sv.Height)
			p.SetLayoutAnimated(AnimationDuration, top, 0, ItemWidth, p.Height)
		Else
			sv.ScrollViewInnerPanel.AddView(p, 0, top, sv.Width, InitialHeight)
			p.SetLayoutAnimated(AnimationDuration, 0, top, p.Width, ItemHeight)
		End If
	End If
	If bHorizontal Then
		sv.ScrollViewContentWidth = sv.ScrollViewContentWidth + ItemWidth - InitialHeight + IncludeDividierHeight
		If items.Size = 1 Then sv.ScrollViewContentWidth = sv.ScrollViewContentWidth + IncludeDividierHeight
	Else
		sv.ScrollViewContentHeight = sv.ScrollViewContentHeight + ItemHeight - InitialHeight + IncludeDividierHeight
		If items.Size = 1 Then sv.ScrollViewContentHeight = sv.ScrollViewContentHeight + IncludeDividierHeight
	End If
End Sub

Private Sub CleanAfterAnimation
	LastAnimatedAction = LastAnimatedAction + 1
	Dim MyIndex As Int = LastAnimatedAction
	Sleep(AnimationDuration + 50)
	If MyIndex <> LastAnimatedAction Then Return
	Dim Top As Int = dividerHeight
	For Each item As CLVItem In items
		If bHorizontal Then
			item.Panel.Left = Top
		Else
			item.Panel.Top = Top
		End If
		Top = Top + item.Height + dividerHeight
	Next
End Sub


'Changes the height of an existing item.
Public Sub ResizeItem(Index As Int, ItemHeight As Int)
	Dim p As B4XView = GetPanel(Index)
	Dim value As Object = items.Get(Index)
	Dim parent As B4XView = p.Parent
	p.Color = parent.Color
	p.RemoveViewFromParent
	If bHorizontal Then ' just in case
		ReplaceAt2(Index, p, ItemHeight, value)
	Else
		ReplaceAt(Index, p, ItemHeight, value)
	End If
End Sub

Public Sub ResizeItem2(Index As Int, ItemWidth As Int)
	Dim p As B4XView = GetPanel(Index)
	Dim value As Object = items.Get(Index)
	Dim parent As B4XView = p.Parent
	p.Color = parent.Color
	p.RemoveViewFromParent
	ReplaceAt2(Index, p, ItemWidth, value)
End Sub

'Replaces the item at the specified index with a new item.
Public Sub ReplaceAt(Index As Int, pnl As B4XView, ItemHeight As Int, Value As Object)
	Dim RemoveItem As CLVItem = items.Get(Index)
	items.RemoveAt(Index)
	RemoveItem.Panel.RemoveViewFromParent
	InsertAtImpl(Index, pnl, ItemHeight, 0, Value, RemoveItem.Height)
End Sub

Public Sub ReplaceAt2(Index As Int, pnl As B4XView, ItemWidth As Int, Value As Object)
	Dim RemoveItem As CLVItem = items.Get(Index)
	items.RemoveAt(Index)
	RemoveItem.Panel.RemoveViewFromParent
	InsertAtImpl(Index, pnl, 0, ItemWidth, Value, RemoveItem.Height)
End Sub


'Adds a custom item.
Public Sub Add(Pnl As B4XView, Value As Object)
	InsertAt(items.Size, Pnl, Value)
End Sub

'Scrolls the list to the specified item (without animating the scroll).
Public Sub JumpToItem(Index As Int)
	If bHorizontal Then
		sv.ScrollViewOffsetX = FindItemTop(Index)
	Else
		sv.ScrollViewOffsetY = FindItemTop(Index)
	End If
End Sub

'Smoothly scrolls the list to the specified item.
Public Sub ScrollToItem(Index As Int)
	#if B4J
	JumpToItem(Index)
	#Else If B4A
	If bHorizontal Then
		Dim hsv As HorizontalScrollView = sv
		hsv.ScrollPosition = FindItemTop(Index) 'smooth scroll
	Else
		Dim nsv As ScrollView = sv
		nsv.ScrollPosition = FindItemTop(Index) 'smooth scroll
	End If
	#End If
End Sub

Private Sub FindItemTop(Index As Int) As Int ' reused as Left for horiz
	Dim top As Int
	For i = 0 To Min(Index - 1, items.Size - 1)
		top = top + GetItem(i).Height + dividerHeight
	Next
	Return top
End Sub


'Gets the index of the first visible item.
Public Sub getFirstVisibleIndex As Int
	Dim bottom As Int ' reused as right for horiz
	For i = 0 To items.Size - 1
		bottom = bottom +  GetItem(i).Height + dividerHeight ' reused as Right for horiz
		If bHorizontal Then
			If bottom > sv.ScrollViewOffsetX Then Return i
		Else
			If bottom > sv.ScrollViewOffsetY Then Return i
		End If
	Next
	Return items.Size - 1
End Sub

'Gets the index of the last visible item.
Public Sub getLastVisibleIndex As Int
	Dim first As Int = getFirstVisibleIndex
	Dim bottom As Int ' reused as right for horiz
	For i = 0 To items.Size - 1
		bottom = bottom +  GetItem(i).Height + dividerHeight
		If bHorizontal Then
			If i >= first And bottom >= sv.ScrollViewOffsetX  + sv.Width Then Return Max(i - 1, first)
		Else
			If i >= first And bottom >= sv.ScrollViewOffsetY  + sv.Height Then Return Max(i - 1, first)
		End If
	Next
	Return items.Size - 1
End Sub

Private Sub PanelClickHandler(SenderPanel As B4XView)
	Dim clr As Int = GetItem(SenderPanel.Tag).Color
	SenderPanel.SetColorAnimated(50, clr, PressedColor)
	If xui.SubExists(CallBack, EventName & "_ItemClick", 2) Then
		CallSub3(CallBack, EventName & "_ItemClick", SenderPanel.Tag, GetItem(SenderPanel.Tag).Value)
	End If
	Sleep(200)
	SenderPanel.SetColorAnimated(200, PressedColor, clr)
End Sub

'Returns the index of the item that holds the given view.
Public Sub GetItemFromView(v As B4XView) As Int
	Dim parent = v As Object, current As B4XView
	Do While sv.ScrollViewInnerPanel <> parent
		current = parent
		parent = current.Parent
	Loop
	v = current
	Return v.Tag
End Sub

Private Sub ScrollHandler
	Dim positionPlus As Int
	Dim contentSize As Int
	If bHorizontal Then
		positionPlus = sv.ScrollViewOffsetX + sv.Width
		contentSize = sv.ScrollViewContentWidth
	Else
		positionPlus = sv.ScrollViewOffsetY + sv.Height
		contentSize = sv.ScrollViewContentHeight
	End If
	If positionPlus  >= contentSize - 5dip And DateTime.Now > LastReachEndEvent + 100 Then
		If xui.SubExists(CallBack, EventName & "_ReachEnd", 0) Then
			LastReachEndEvent = DateTime.Now
			CallSubDelayed(CallBack, EventName & "_ReachEnd")
		Else
			LastReachEndEvent = DateTime.Now + 1000 * DateTime.TicksPerDay 'disable
		End If
	End If
End Sub


'******************************* platform specific ***************************************************

#If B4A

Private Sub CreateScrollView As B4XView
	If bHorizontal Then
		Dim hsv As HorizontalScrollView
		hsv.Initialize(0, "sv")
		Return hsv
	Else
		Dim nsv As ScrollView
		nsv.Initialize2(0, "sv")
		Return nsv
	End If
End Sub

Private Sub Panel_Click
	PanelClickHandler(Sender)
End Sub

Private Sub sv_ScrollChanged(Position As Int)
	ScrollHandler
End Sub

Private Sub CreatePanel (PanelEventName As String) As B4XView
	Dim pnl As Panel
	pnl.Initialize(PanelEventName)
	Return pnl
End Sub

Private Sub CreateLabel(txt As String) As B4XView
	Dim lbl As Label
	lbl.Initialize("")
	lbl.Gravity = DesignerLabel.Gravity
	lbl.TextSize = DesignerLabel.TextSize
	lbl.SingleLine = False
	lbl.Text = txt
	If bHorizontal Then
		Dim ijk As Int = 1 ' not sure what to use here
		'lbl.Width = 50dip
		'lbl.Height = sv.ScrollViewContentHeight - 10dip
		Dim canvas1 As Canvas
		Dim dum As Bitmap
		dum.InitializeMutable(20dip,20dip)
		canvas1.Initialize2(dum)
		Dim oTypeFace As Typeface
		oTypeFace = DesignerLabel.Typeface
		If oTypeFace.IsInitialized = False Then oTypeFace = Typeface.DEFAULT
		Dim nTextSize As Float = DesignerLabel.TextSize
		Dim nTextWidth As Int = canvas1.MeasureStringWidth(txt,oTypeFace,nTextSize)
		lbl.Width = nTextWidth
		lbl.Height = su.MeasureMultilineTextHeight(lbl, txt) ' or DesignerLabel.Height or sv.Height
	Else
		lbl.Width = sv.ScrollViewContentWidth - 10dip
		lbl.Height = su.MeasureMultilineTextHeight(lbl, txt)
	End If
	Return lbl
End Sub

#else If B4i
' not converted xxx to bHorizontal
xxx

Private Sub CreateScrollView As B4XView
	Dim nsv As ScrollView
	nsv.Initialize("sv", 0, 0)
	Return nsv
End Sub

Private Sub Panel_Click
	PanelClickHandler(Sender)
End Sub

Sub sv_ScrollChanged (OffsetX As Int, OffsetY As Int)
	ScrollHandler
End Sub

Private Sub CreatePanel (PanelEventName As String) As B4XView
	Dim pnl As Panel
	pnl.Initialize(PanelEventName)
	Return pnl
End Sub

Private Sub CreateLabel(txt As String) As B4XView
	Dim lbl As Label
	lbl.Initialize("")
	lbl.TextAlignment = DesignerLabel.TextAlignment
	lbl.Font = DesignerLabel.Font
	lbl.Multiline = True
	lbl.Text = txt
	lbl.Width = sv.ScrollViewContentWidth - 10dip
	lbl.SizeToFit
	Log(lbl.Height)
	Return lbl
End Sub

#else If B4J
Private Sub CreateScrollView As B4XView
	Dim nsv As ScrollPane
	nsv.Initialize("sv")
	nsv.SetHScrollVisibility("NEVER")
	Return nsv
End Sub

Private Sub Panel_MouseClicked (EventData As MouseEvent)
	PanelClickHandler(Sender)
End Sub

Private Sub sv_VScrollChanged (Position As Double)
	ScrollHandler
End Sub

Private Sub CreatePanel (PanelEventName As String) As B4XView
	Dim pnl As Pane
	pnl.Initialize(PanelEventName)
	Return pnl
End Sub

Private Sub CreateLabel(txt As String) As B4XView
	Dim lbl As Label
	lbl.Initialize("")
	lbl.Alignment = DesignerLabel.Alignment
	lbl.Style = DesignerLabel.Style
	lbl.Font = DesignerLabel.Font
	lbl.WrapText = True
	lbl.Text = txt
	Dim jo As JavaObject = Me
	Dim width As Double = sv.ScrollViewContentWidth - 10dip
	lbl.PrefHeight = 20dip + jo.RunMethod("MeasureMultilineTextHeight", Array(lbl.Font, txt, width))
	Return lbl
End Sub


#if Java

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import javafx.scene.text.Font;
import javafx.scene.text.TextBoundsType;
public double MeasureMultilineTextHeight(Font f, String text, double width) throws Exception {
		Method m = Class.forName("com.sun.javafx.scene.control.skin.Utils").getDeclaredMethod("computeTextHeight",
				Font.class, String.class, double.class, TextBoundsType.class);
		m.setAccessible(true);
		return (Double)m.invoke(null, f, text, width, TextBoundsType.LOGICAL);
	}
#End If

#End If